/* MAPMAKER.PIKE - Programmed by Maarten Hofman */
/* 120404: Started programming */
/* 300404: Added the possibility for comments */
/* 140904: Added the transpose option */

int main(int argc,string *argv) {
string data,*lines,*ys,y,insert;
int i,j,x1,z1,x2,z2,tx,tz;
float gradient;

  if(argc<2) {
    werror("Usage: mapmaker.pike <file>\n");
    exit(1);
  }
  data=Stdio.read_file(argv[1]);
  if(!data) {
    werror("Failed to read file: "+argv[1]+"!\n");
    exit(2);
  }
  lines=data/"\n";
  ys=allocate(100);
  for(i=0;i<sizeof(ys);i++) {
    ys[i]="00000000000000000000000000000000000000000000000000";
    ys[i]+="00000000000000000000000000000000000000000000000000";
  }
  tx=0;
  tz=0;
  for(i=0;i<sizeof(lines)-1;i++) {
    if(lines[i][0..0]=="#") continue;
    /* Transpose command */
    if(lines[i][0..0]=="!") {
      sscanf(lines[i],"! %d,%d %*s",tx,tz);
      continue;
    }
    if(sscanf(lines[i],"%s %d-%d %d %f",y,z1,z2,x1,gradient)==5) {
      z1+=tz;
      z2+=tz;
      x1+=tx;
      /* Drawing a line instead of a field */
      for(j=z1;j<=z2;j++) {
        x2=(int)(x1+(j-z1)*gradient);
        ys[j]=ys[j][0..(x2-1)]+y+y+ys[j][(x2+2)..];
      }
      continue;
    }
    if(sscanf(lines[i],"%s <%d,%d>-<%d,%d>",y,x1,z1,x2,z2)!=5) {
      werror("Scanning error on line "+i+"\n");
      continue;
    }
    z1+=tz;
    z2+=tz;
    x1+=tx;
    x2+=tx;
    insert="";
    for(j=x1;j<=x2;j++) insert+=y;
    for(j=z1;j<=z2;j++) {
      ys[j]=ys[j][0..(x1-1)]+insert+ys[j][(x2+1)..];
    }
  }
  for(i=0;i<sizeof(ys);i++) {
    write(ys[i]+"\n");
  }
}

