/* CONNECT.PIKE - Programmed by Maarten Hofman */
/* 120404: Started programming */
/* 150404: Made it possible to trigger things in rooms */
/* 210404: Made it possible to say things */
/* 220404: Made it possible to attack other players */
/* 260404: Adding init_game call */
/* 280404: Added the shutdown call */
/* 300404: Fixed state stuff and added more commands */
/* 030504: Added inventory command */
/* 090504: Added drop item command */
/* 110504: Added password to the login command */
/* 070704: Added score command */
/* 300704: Added examine command */
/* 230804: Added shop related commands */
/* 270904: Added look command */
/* 061204: Added tell command */
/* 140205: Added spell command */
/* 160305: Keep player active (reset_idle) */

#include <simulate.h>
#define BLOCK 1520

inherit Stdio.File : socket;
inherit Stdio.File : file;


/* Variables for the communication part */
int offset;
string input,result,state,teller;
object game,player;

void create(object f) {
  werror("Creating new connection object.\n");
  offset=0;
  input="";
  result="";
  game=(object)"game";
  state="login";
  socket::assign(f);
  socket::set_nonblocking(read_callback,send_callback,selfdestruct);
}

int check_password(string name,string password) {
string data,pw;

  data=Stdio.read_file("/home/mhofman/Pike/Server/players/"+name+".o");
  if(!data) return 0;
  if(strstr(data,"\npassword="+password+"\n")>0) return 1;
  return 0;
}

void selfdestruct() {
  player->set_connection(0);
  destruct(this_object());
}

void send_callback() {
int written;
string data;

  if((offset+BLOCK-1)>=strlen(result)) {
    data=result[offset..];
  }
  else {
    data=result[offset..offset+BLOCK-1];
  }
  if(strlen(data)>0) {
    written=socket::write(data);
    if(written>=0) {
      offset+=written;
      return;
    }
    selfdestruct();
    return;
  }
  result="";
  offset=0;
}

void read_callback(mixed id,string data) {
int loc;
string command,answer,*words;

  if(player) player->reset_idle();
  input+=data;
  werror(input);
  loc=strstr(input,"\n");
  if(loc<0) return;
  command=input[0..(loc-1)];
  input=input[(loc+1)..];
  command-="\r";
  werror(command+"\n");
  words=command/" ";
  if((state=="login")&&(words[0]!="login")) {
    answer="991 Not yet logged in.\n";
  }
  else {
    switch(words[0]) {
      case "login":
        if(state!="login") {
          answer="999 Already logged in\n";
          break;
        }
        if(!check_password(words[1],words[2])) {
          answer="987 Invalid password\n";
          break;
        }
        state="active";
        answer="000 Welcome\n";
        player=game->add_player(this_object(),words[1]);
        break;
      case "look":
        answer="000 Welcome\n";
        player=game->add_player(this_object(),player->get_name());
        break;
      case "move":
        answer=game->move(player,words[1]);
        break;
      case "spell":
        answer=game->spell(player,words[1]);
        break;
      case "attack":
        answer=game->attack(player,words[1]);
        break;
      case "trigger":
        answer=player->trigger_activated();
        break;
      case "score":
        answer=player->score_list();
        break;
      case "examine":
        answer=game->examine_closest(player);
        break;
      case "say":
        if(teller) {
          answer=game->tell_player(player,teller,words[1..]*" ");
          teller=0;
          break;
        }
        answer=game->say_text(player,words[1..]*" ");
        break;
      case "shout":
        answer=game->shout_text(player,words[1..]*" ");
        break;
      case "tell":
        teller=words[1];
        answer="008 Next text will be told to "+words[1]+".\n";
        break;
      case "who":
        answer=game->who_list();
        break;
      case "drop":
        answer=player->drop_item(words[1]);
        break;
      case "use":
        answer=player->use_item(words[1]);
        break;
      case "inventory":
        answer=player->inventory_list();
        break;
      case "help":
        answer=game->help(words[1]);
        break;
      case "list":
        words+=({0});
      case "buy":
      case "sell":
        answer=player->handle_shop(words[0],words[1]);
        break;
      default:
        answer="998 Unknown command\n";
        break;
    }
  }
  if(sizeof(result)>0) {
    result+=answer;
    return;
  }
  result=""+answer;
  if(strstr(input,"\n")>0) {
    werror("Recalling read_callback: backlog\n");
    call_out(read_callback,0,0,"");
  }
  send_callback();
}

void add_message(string how) {
  if(sizeof(result)>0) {
    result+=how;
    return;
  }
  result=""+how;
  send_callback();
}
