/* ITEM.PIKE - Programmed by Maarten Hofman */
/* 100404: Started programming */
/* 150404: Adding triggers */
/* 210404: Made it possible to say things */
/* 220404: Add hit points */
/* 270404: Added the resurrect function */
/* 280404: Extracted the item functionality from the player */
/* 030504: Added the pickup functionality */
/* 090504: Added the long description */
/* 100504: Added the "occupies" function */
/* 050704: Added the possibility to give it a value */
/* 070704: Gold should be added to the living */
/* 191004: Added is_quest_item() */
/* 081104: Added a dummy get_sound() */

#include <simulate.h>

string name,texture,model,location,short,type,description;
int x,y,z,can_pickup,canuse,value,questitem,no_drop;
object room,game;

void create() {
  game=(object)"../game";
  short=0;
  can_pickup=1;
  canuse=0;
  type="basic";
  questitem=0;
  no_drop=0;
}

int can_pick_up() {
  return can_pickup;
}

int cant_drop() {
  return no_drop;
}

int is_quest_item() {
  return questitem;
}

int can_use() {
  return canuse;
}

string get_texture() {
  return texture;
}

string get_model() {
  return model;
}

void set_x(int how) {
  x=how;
}

void set_y(int how) {
  y=how;
}

void set_z(int how) {
  z=how;
}

int get_x() {
  return x;
}

int get_y() {
  return y;
}

int get_z() {
  return z;
}

string get_name() {
  return name;
}

void set_short(string how) {
  short=how;
}

string get_short() {
  if(!short) return name;
  return short;
}

void set_name(string how) {
  name=how;
}

void set_location(string how) {
  location=how;
}

string get_location() {
  return location;
}

void set_room(object how) {
  room=how;
}

object get_room() {
  return room;
}

string pick_up(object player) {
  if(room!=player->get_room()) {
    werror("Already picked up!\n");
    return "996 No item\n";
  }
  if(player->get_x()!=x) {
    werror("Unmatching X "+player->get_x()+":"+x+"\n");
    return "996 No Item\n";
  }
  if(player->get_z()!=z) {
    werror("Unmatching Z "+player->get_z()+":"+z+"\n");
    return "996 No Item\n";
  }
  player->remove_item_trigger();
  if(type=="gold") {
    player->add_gold(value);
    game->remove_item(this_object());
    return "008 You picked up "+value+" gold coins\n";
  }
  room=player;
  player->add_item(this_object());
  game->say(player,"015 REMOVE "+name+"\n");
  return "008 You picked up the "+short+"\n";
}

string get_long() {
  return get_short();
}

string get_type() {
  return type;
}

int occupies(int px,int pz) {
  if(x!=px) return 0;
  if(z!=pz) return 0;
  return 1;
}

int get_value() {
  return value;
}

void set_value(int how) {
  value=how;
}

string get_description() {
  return description;
}

string get_sound() {
  return 0;
}

void gets_wet(object who) {
}

