/* STICK.PIKE - Programmed by Maarten Hofman */
/* 280205: Started programming */
/* 030305: Added point light stuff */
/* 060305: Added use model */

inherit "item";

int timeleft;
string base;

void create() {
  ::create();
  name="stick";
  base="stick";
  model="stick.txt";
  texture="items8_.tm2";
  value=20;
  description="008 A wooden stick.\n";
  canuse=1;
  timeleft=1000;
  type=0;
}

void out_of_fuel() {
object pl;

  type=0;
  pl=game->get_pointlight();
  timeleft=0;
  value=2;
  description="008 A burnt "+base+".\n";
  short=base+" (burnt)";
  if(room->is_player()) {
    pl->remove_point_light_object(room);
    room->set_special_item(0);
  }
  else {
    pl->remove_point_light_place(x,y,z);
  }
}

void gets_wet(object who) {
  if(type=="torch") {
    remove_call_out(out_of_fuel);
    out_of_fuel();
  }
  timeleft=0;
  value=2;
  description="008 A wet "+base+".\n";
  short=base+" (wet)";
}

string use(object player) {
object rr,pl;

  if(player->is_frog()) return "008 Frogs can't use torches!\n";
  rr=room;
  pl=game->get_pointlight();
  if(rr->is_player()) rr=rr->get_room();
  if(type=="torch") {
    type=0;
    description="008 A "+base+".\n";
    short=base;
    game->recheck_light(rr);
    pl->remove_point_light_object(player);
    timeleft=remove_call_out(out_of_fuel);
    value=timeleft/50;
    if(value<2) value=2;
    player->set_special_item(0);
    return "008 You extinguish the "+base+".\n";
  }
  else {
    if(!timeleft) return "008 The "+base+" doesn't want to burn anymore.\n";
    type="torch";
    description="008 A burning "+base+".\n";
    short=base+" (lit)";
    game->recheck_light(rr);
    pl->add_point_light_object(player);
    call_out(out_of_fuel,timeleft,player);
    player->set_special_item(this_object());
    return "008 You light the "+base+".\n";
  }
}

int get_y() {
  /* If we are picked up, we have different coordinates */
  if(!room) return ::get_y();
  if(room->is_player()) return room->get_y();
  return ::get_y();
}

void set_room(object how) {
object pl;

  if(how==room) return;
  if(type!="torch") {
    ::set_room(how);
    return;
  }
  if(!room) {
    ::set_room(how);
    return;
  }
  pl=game->get_pointlight();
  if(how->is_player()) {
    /* We are picked up while lit */
    pl->remove_point_light_place(x,y,z);
    pl->add_point_light_object(how);
    ::set_room(how);
    how->set_special_item(this_object());
    return;
  }
  /* We are dropped while lit */
  pl->remove_point_light_object(room);
  pl->add_point_light_place(x,y,z);
  ::set_room(how);
}

string get_use_model() {
  return "Atorch.txt";
}

string get_use_texture() {
  return "items8_.tm2";
}

string pick_up(object player) {
object pl;

  if(type=="torch") {
    pl=game->get_pointlight();
    /* We are picked up while lit */
    pl->remove_point_light_place(x,y,z);
    pl->add_point_light_object(player);
    player->set_special_item(this_object());
  }
  return ::pick_up(player);
}

