/* LIVING.PIKE - Programmed by Maarten Hofman */
/* 100404: Started programming */
/* 150404: Adding triggers */
/* 210404: Made it possible to say things */
/* 220404: Add hit points */
/* 270404: Added the resurrect function */
/* 280404: Moved some functionality to the item inheritance */
/* 300404: Added more fighting functionality */
/* 030504: Added object triggers */
/* 090504: Added drop item ability */
/* 100504: Moved some parts to living.pike */
/* 110504: Added the dropping of items when dying */
/* 170504: Added who to hit_player() */
/* 180504: Added gold coins */
/* 010804: Added heal() function */
/* 040804: Gold will also be dropped when dying */
/* 140904: Added experience points */
/* 181004: Added is_ghost() */
/* 191004: Added race */
/* 040405: Remove gold coins when dropping dead */

#include <simulate.h>

inherit "items/item";

/* Variables for the player part */
string trigname;
int current_hp,max_hp,attacking,att,def,player,gender,level,gold,current_sp;
int max_sp;
object weapon,armour,*items;

/* Variables in general */
string race;

void create() {
  ::create();
  texture="axes_.tm2";
  model="player.ani";
  current_hp=50;
  max_hp=50;
  current_sp=50;
  max_sp=50;
  /* By default, we are the weapon and armour (fists and skin) */
  weapon=this_object();
  armour=this_object();
  att=10;
  def=8;
  items=({});
  can_pickup=0;
  player=0;
  /* By default a living is neutral */
  gender=0;
  level=1;
  attacking=0;
  gold=0;
  race="human";
}

string get_race() {
  return race;
}

int is_ghost() {
  return 0;
}

int is_frog() {
  return 0;
}

int is_player() {
  return player;
}

void add_item(object what) {
  items+=({what});
}

/* Start of weapon and armour functions */
int get_attack_modifier() {
  return -3;
}

int get_damage(object who) {
int throw;

  throw=random(6)-2;
  if(throw<0) return 0;
  return throw;
}

int get_defense_modifier() {
  return -5;
}

int get_armour_class() {
  return 0;
}

void use(int how) {
}
/* End of weapon and armour functions */

int attack(object who) {
int throw,damage;

  throw=random(20)+1;
  werror("Throw: "+throw+" Att: "+(att+weapon->get_attack_modifier())+"\n");
  if(throw>att+weapon->get_attack_modifier()) return 0;
  damage=weapon->get_damage(who);
  if(throw<3) damage=-damage;
  return damage;
}

int defend() {
int throw;

  throw=random(20)+1;
  if(throw>def+weapon->get_defense_modifier()) return 0;
  return 1;
}

void set_room(object how) {
int i;

  ::set_room(how);
}

int get_attacking() {
  return attacking;
}

void reset_attacking() {
  werror(name+" has attacking reset\n");
  attacking=0;
}

void set_attacking() {
  attacking=1;
  call_out(reset_attacking,1);
}

void drop_dead() {
object spot,corpse,ogold;
int i;

  /* Unwield weapon and armour */
  weapon->use(0,this_object());
  armour->use(0,this_object());
  weapon=this_object();
  armour=this_object();
  /* If possible add a body to the playing field as well */
  spot=game->drop_spot(this_object());
  if(spot) {
    /* We have a spot. Clone a body */
    corpse=clone((program)"items/corpse");
    corpse->set_x(spot->get_x());
    corpse->set_y(spot->get_y());
    corpse->set_z(spot->get_z());
    corpse->set_room(room);
    game->add_item(corpse);
  }
  else {
    werror("No spot available!\n");
  }
  if(gold>0) {
    /* Drop gold */
    spot=game->drop_spot(this_object());
    if(spot) {
      ogold=clone((program)"items/gold");
      ogold->set_value(gold);
      ogold->set_x(spot->get_x());
      ogold->set_y(spot->get_y());
      ogold->set_z(spot->get_z());
      ogold->set_room(room);
      game->add_item(ogold);
    }
    gold=0;
  }
  /* Drop all items */
  for(i=0;i<sizeof(items);i++) {
    spot=game->drop_spot(this_object());
    if(!spot) break;
    items[i]->set_x(spot->get_x());
    items[i]->set_y(spot->get_y());
    items[i]->set_z(spot->get_z());
    items[i]->set_room(room);
    game->add_item(items[i]);
    items[i]=0;
  }
  /* There might be items left, because there might not have been any room */
  for(i=0;i<sizeof(items);i++) {
    if(items[i]) game->remove_item(items[i]);
  }
  items=({});
}

void hit_player(int how,object who) {
  werror("HitPlayer: "+how+"\n");
  current_hp=current_hp-how;
  if(current_hp<0) {
    /* Living died */
    game->say(this_object(),
              "015 REMOVE "+name+"\n");
    drop_dead();
    game->remove_living(this_object());
  }
}

int get_gold() {
  return gold;
}

int add_gold(int how) {
  gold+=how;
  if(gold<0) {
    gold-=how;
    return 0;
  }
  return 1;
}

string get_description() {
string desc;

  desc="008 "+get_short()+" ("+level+")";
  if(current_hp==max_hp) {
    desc+=" looks healthy";
  }
  else {
    if(current_hp>max_hp/2) {
      desc+=" is wounded";
    }
    else {
      desc+=" is heavily wounded";
    }
  }
  return desc+".\n";
}

string get_statistics() {
string desc;

  desc="008 "+get_short()+" ("+level+") HP: "+current_hp+".\n";
  return desc;
}

void heal(int how) {
  current_hp+=how;
  current_sp+=how;
  if(current_hp>max_hp) current_hp=max_hp;
  if(current_sp>max_sp) current_sp=max_sp;
}

int get_level() {
  return level;
}

