/* MONSTER.PIKE - Programmed by Maarten Hofman */
/* 170504: Started programming */
/* 180504: The attacker might suddenly disappear */
/* 041004: Added size */
/* 270205: Added spells */
/* 260305: Changed closest living part */
/* 100405: Added fast option */

inherit "../living";

object attacker;
int hb,hit_dice,size,aggressive,maxx,minx,maxz,minz,annoy,spells,fast,chch;
string *chats;

void create() {
  ::create();
  hb=0;
  hit_dice=1;
  size=1;
  aggressive=0;
  weapon=this_object();
  armour=this_object();
  location="village";
  spells=0;
  fast=0;
  chch=5;
}

void heart_beat() {
string result;
int whichat;

  /* Make sure we are vocal about things */
  if(chats) {
    if(!random(chch)) {
      whichat=random(sizeof(chats));
      game->say(this_object(),chats[whichat]);
    }
  }
  /* We were attacked, fight back */
  if(attacker) {
    result=0;
    if(!annoy) {
      if((spells)&&(!random(5))) {
        result=game->monster_spell(this_object(),attacker);
      }
      else {
        result=game->monster_attack(this_object(),attacker,size);
      }
    }
    if(result) {
      /* And attack again after one second */
      call_out(heart_beat,1);
      return;
    }
    if(!aggressive) {
      hb=0;
      return;
    }
    if(!attacker->is_ghost()) {
      if((attacker->get_room()==get_room())||(aggressive==2)) {
        /* 
         * Attacker is not a ghost and in the same room, so follow. Also follow
         * in case of annoying.
         */
        result=game->monster_move(this_object(),attacker->get_x(),
                                  attacker->get_z());
        if(result) {
          if(!fast) {
            call_out(heart_beat,1);
          }
          else {
            call_out(heart_beat,0.4);
          }
          return;
        }
      }
    }
  }
  hb=0;
  annoy=0;
}

void hit_player(int how,object who) {
  attacker=who;
  annoy=0;
  if(!hb) {
    hb=1;
    call_out(heart_beat,0);
  }
  ::hit_player(how,who);
}

void set_level(int how) {
int i;

  level=how;
  att+=level/2;
  att-=3;
  if(att>18) att=18;
  def+=level/2;
  def-=1;
  if(def>17) def=17;
  for(i=0;i<level;i++) {
    max_hp=max_hp+random(6)+1;
  }
  max_hp=max_hp/2;
  current_hp=max_hp;
  hit_dice=1+(level/6);
  werror("Att: "+att+" Def: "+def+" MaxHP: "+max_hp+" CurrentHP: "+current_hp+" HitDice: "+hit_dice+" Level: "+level+"\n");
}

int get_attack_modifier() {
  return 0;
}

int get_damage(object who) {
int throw,i;

  throw=0;
  for(i=0;i<hit_dice;i++) throw+=random(6)+1;
  throw+=level%6;
  return throw;
}

int get_defense_modifier() {
  return 0; 
}

int get_armour_class() {
  return level;
}

void aggressive_check() {
object cp,room;
int nx,nz;

  if(!hb) {
    /* Find a potential player to attack/annoy */
    cp=game->find_closest(this_object(),1);
    room=0;
    if(cp) room=cp->get_room();
    if(room==get_room()) {
      attacker=cp;
      if(aggressive==2) annoy=1;
      call_out(heart_beat,1);
      hb=1;
    }
    else {
      /* Aggressive monsters might as well look for trouble */
      nx=get_x()+random(3)-1;
      nz=get_z()+random(3)-1;
      if(maxx+maxz-minx-minz) {
        if(nx<minx) nx=minx;
        if(nz<minz) nz=minz;
        if(nx>maxx) nx=maxx;
        if(nz>maxz) nz=maxz;
      }
      game->monster_move(this_object(),nx,nz);
    }
  }
  if(!fast) {
    call_out(aggressive_check,60);
  }
  else {
    call_out(aggressive_check,20);
  }
}

void set_aggressive(int how) {
  remove_call_out(aggressive_check);
  aggressive=how;
  if(aggressive) {
    if(!fast) {
      call_out(aggressive_check,60);
    }
    else {
      call_out(aggressive_check,20);
    }
  }
}

void set_bounds(int a,int b,int c,int d) {
  minx=a;
  maxx=b;
  minz=c;
  maxz=d;
}

string get_monster_description() {
string result;

  result="001 NAME "+name+" MODEL "+model+" TEXTURE "+texture+"\n";
  result+="003 LOCATE "+name+" X "+x+" Y "+y+" Z "+z+"\n";
  return result;
}
