/* POINTLIGHT.PIKE - Programmed by Maarten Hofman */
/* 040305: Started programming */

object *pointlights;
object game;
mapping players;

void create() {
  pointlights=({});
  players=([]);
}

string player_point_light(object who,int force) {
string msg,name;
int i,distance,curdist,x,y,z,xdiff,ydiff,zdiff;
object cpl;

  x=who->get_x();
  y=who->get_y();
  z=who->get_z();
  distance=-1;
  msg="025 PLOFF\n";
  for(i=0;i<sizeof(pointlights);i++) {
    cpl=pointlights[i];
    xdiff=x-cpl->get_x();
    ydiff=y-cpl->get_y();
    zdiff=z-cpl->get_z();
    curdist=xdiff*xdiff+ydiff*ydiff+zdiff*zdiff;
    if((distance<0)||(curdist<distance)) {
      distance=curdist;
      if(cpl->get_name()=="spot") {
        msg="025 PLON PLACE "+cpl->get_x()+","+cpl->get_y()+","+cpl->get_z()+"\n";
      }
      else {
        name=cpl->get_name();
        msg="025 PLON BLOB "+name+"\n";
        if(name[0..4]=="spell") msg+="025 PLCOLOUR 150,150,150\n";
      }
    }
  }
  if(players[who]==msg) {
    if(force) return msg;
    return 0;
  }
  players[who]=msg;
  return msg;
}

void set_game(object how) {
  game=how;
}

void notify_change() {
  game->point_light_change();
}

void add_point_light_object(object which) {
  pointlights+=({which});
  pointlights-=({0});
  remove_call_out(notify_change);
  call_out(notify_change,0);
}

void add_point_light_place(int x,int y,int z) {
object spot;

  spot=clone((program)"spot");
  spot->set_xyz(x,y,z);
  add_point_light_object(spot);
}

void remove_point_light_object(object which) {
  pointlights-=({which});
  remove_call_out(notify_change);
  call_out(notify_change,0);
}

void remove_point_light_place(int x,int y,int z) {
int i;
object spot;

  spot=0;
  for(i=0;i<sizeof(pointlights);i++) {
    spot=pointlights[i];
    if(!spot) continue;
    if(spot->get_name()!="spot") continue;
    if(spot->get_x()!=x) continue;
    if(spot->get_y()!=y) continue;
    if(spot->get_z()==z) {
      remove_point_light_object(spot);
      return;
    }
  }
  werror("Couldn't remove point light from place.\n");
}
    
