/* ROOM.PIKE - Programmed by Maarten Hofman */
/* 120404: Started programming */
/* 190404: get_y() returns Y and check is different */
/* 270404: Added the -4 to the maps */
/* 280404: Added the get_real_effect */
/* 300704: Added the descriptions list */
/* 310704: Changed the descriptions list */
/* 010804: Added retrieving of updates */
/* 251004: Added properties check */
/* 160205: Added roomname checks */

string description,roomname;
string *zs;
object game;
string *properties;

void create() {
  properties=({});
  description="\n";
  zs=({});
  call_out(reset,1);
}

string get_room_name() {
  return roomname;
}

void reset() {
}

void set_game(object how) {
  game=how;
}

void set_property(string what) {
  properties+=({what});
}

int get_property(string what) {
int i;

  for(i=0;i<sizeof(properties);i++) {
    if(properties[i]==what) return 1;
  }
  return 0;
}

int load_file(string fn) {
string data;

  roomname=fn;
  data=Stdio.read_file(fn+".room");
  if(!data) {
    werror("Load of room "+fn+" failed\n");
    return 0;
  }
  description=data;
  data=Stdio.read_file(fn+".map");
  if(data) zs=data/"\n";
  return 1;
}

string get_update() {
  return "";
}

string get_description() {
  return description;
}

int get_real_y(int x,int z) {
  return 0;
}

int get_y(int x,int z) {
int effect;

  effect=get_effect(x,z);
  if(effect<0) return get_real_y(x,z);
  if(effect==25) return -40;
  return effect;
}

int get_processed_effect(int x,int z) {
  return 0;
}

int get_real_effect(int x,int z) {
int mx,mz;
int value;

  if(!zs) return 0;
  mx=x%100;
  mz=z%100;
  if(mz>=sizeof(zs)) return 0;
  if(mx>=sizeof(zs[mz])) return 0;
  if(mx<0) return 0;
  if(mz<0) return 0;
  value=zs[mz][mx];
  return value;
}

int get_effect(int x,int z) {
int value;

  value=get_real_effect(x,z);
  if(value-'a'>0) {
    return value-'a';
  }
  if(value=='1') return -1;
  if(value=='2') return -2;
  if(value=='4') return -4;
  if(value=='3') return get_processed_effect(x,z);
  return 0;
}

void trigger_hit(object who) {
}

string trigger_activated(object who) {
  return "996 No trigger\n";
}

int distance(object a,int x,int y,int z) {
int xt,yt,zt;

  xt=a->get_x()-x;
  xt=xt*xt;
  yt=a->get_y()-y;
  yt=yt*yt;
  zt=a->get_z()-z;
  zt=zt*zt;
  return xt+yt+zt;
}

mixed *closest_view(object player) {
  return ({1000003,"Nothing here."});
}

string handle_shop(object who,string action,mixed item) {
  return "008 No shop available!\n";
}

int get_light(object who) {
  return 1;
}

int torch_check(object what) {
  return 1;
}

int is_player() {
  return 0;
}

string tie_rope() {
  return 0;
}

